Skip site navigation (1)Skip section navigation (2)
Date:      Sat, 4 Dec 2010 11:45:25 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-projects@freebsd.org
Subject:   svn commit: r216182 - projects/stress2/misc
Message-ID:  <201012041145.oB4BjPiR064354@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Sat Dec  4 11:45:24 2010
New Revision: 216182
URL: http://svn.freebsd.org/changeset/base/216182

Log:
  Added three new truncate test scenarios.

Added:
  projects/stress2/misc/truncate3.sh   (contents, props changed)
  projects/stress2/misc/truncate4.sh   (contents, props changed)
  projects/stress2/misc/truncate5.sh   (contents, props changed)

Added: projects/stress2/misc/truncate3.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/truncate3.sh	Sat Dec  4 11:45:24 2010	(r216182)
@@ -0,0 +1,124 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2010 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD: projects/stress2/misc/rename.sh 191485 2009-04-25 10:19:36Z pho $
+#
+
+# Variation of truncate2.sh whih FS check added.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+mount | grep -q "$mntpoint" && umount $mntpoint
+mdconfig -l | grep -q $mdstart &&  mdconfig -d -u $mdstart
+
+mdconfig -a -t swap -s 400m -u $mdstart
+bsdlabel -w md${mdstart} auto
+
+newfs -U md${mdstart}${part} > /dev/null
+mount /dev/md${mdstart}${part} $mntpoint
+export RUNDIR=$mntpoint/stressX
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > truncate3.c
+cc -o truncate3 -Wall -O2 truncate3.c
+rm -f truncate3.c
+[ -d $RUNDIR ] || mkdir -p $RUNDIR
+cd $RUNDIR
+
+/tmp/truncate3
+
+cd $here
+rm -f /tmp/truncate3
+
+sync;sync;sync
+while mount | grep -q $mntpoint; do
+	sync;sync;sync
+	sleep 1
+	umount $mntpoint
+done
+
+if fsck -n -t ufs /dev/md${mdstart}${part} | egrep -q "BAD|WRONG"; then
+	fsck -n -t ufs /dev/md${mdstart}${part}
+fi
+
+mdconfig -d -u $mdstart
+exit 0
+EOF
+#include <fcntl.h>
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <sys/wait.h>
+
+#define SIZ 512
+char buf[SIZ];
+
+void
+test(void)
+{
+	int fd[10], i, j;
+	char name[128];
+	off_t len;
+
+	for (j = 0; j < 10; j++) {
+		sprintf(name, "%05d.%05d", getpid(), j);
+		fd[j] = open(name, O_WRONLY | O_CREAT | O_APPEND, 0666);
+		if (fd[j] == -1)
+			err(1, name);
+		unlink(name);
+	}
+
+	for (i = 0; i < 100; i++) {
+		for (j = 0; j < 10; j++) {
+			if (write(fd[j], buf, 2) != 2)
+				err(1, "write");
+			len = arc4random() % 1024 * 1024;
+			if (ftruncate(fd[j], len) == -1)
+				err(1, "ftruncate");
+		}
+	}
+
+	exit(0);
+}
+int
+main(int argc, char **argv)
+{
+	int i, status;
+
+	for (i = 0; i < 20; i++) {
+		if (fork() == 0) 
+			test();
+	}
+	for (i = 0; i < 20; i++)
+		wait(&status);
+
+	return (0);
+}

Added: projects/stress2/misc/truncate4.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/truncate4.sh	Sat Dec  4 11:45:24 2010	(r216182)
@@ -0,0 +1,57 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2010 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD: projects/stress2/misc/suj.sh 210724 2010-08-01 10:33:03Z pho $
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# fsck fails with "PARTIALLY ALLOCATED INODE I=4"
+# Test scenario by Bruce Cran <bruce cran org uk>
+
+. ../default.cfg
+
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 1g -u $mdstart
+bsdlabel -w md$mdstart auto
+newfs -U md${mdstart}$part > /dev/null
+for size in $((4 * 1024 * 1024 * 1024 - 1)) $((4 * 1024 * 1024 * 1024)); do
+	mount /dev/md${mdstart}$part $mntpoint
+
+	echo "Truncate file size: $size"
+	truncate -s $size $mntpoint/f1 && rm $mntpoint/f1
+
+	while mount | grep "$mntpoint " | grep -q /dev/md; do
+		umount $mntpoint || sleep 1
+	done
+	fsck -t ufs -y /dev/md${mdstart}$part 2>&1 | tee /tmp/fsck.log | \
+		     grep -v "IS CLEAN" | egrep -q  -m1 "[A-Z][A-Z]" && \
+		     cat /tmp/fsck.log
+done
+mdconfig -d -u $mdstart
+rm -f /tmp/fsck.log

Added: projects/stress2/misc/truncate5.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/truncate5.sh	Sat Dec  4 11:45:24 2010	(r216182)
@@ -0,0 +1,110 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2010 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD: projects/stress2/misc/rename.sh 191485 2009-04-25 10:19:36Z pho $
+#
+
+# "panic: handle_workitem_freeblocks: inode 447489 block count 336" seen.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+mount | grep -q "$mntpoint" && umount $mntpoint
+mdconfig -l | grep -q $mdstart &&  mdconfig -d -u $mdstart
+
+mdconfig -a -t swap -s 1g -u $mdstart
+bsdlabel -w md${mdstart} auto
+
+newfs -U md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > truncate5.c
+cc -o truncate5 -Wall -Wextra -O2 truncate5.c
+rm -f truncate5.c
+
+export RUNDIR=$mntpoint/stressX
+[ -d $RUNDIR ] || mkdir -p $RUNDIR
+cd $RUNDIR
+
+/tmp/truncate5
+
+cd $here
+rm -f /tmp/truncate5
+
+while mount | grep -q md${mdstart}$part; do
+	umount $mntpoint || sleep 1
+done
+
+if fsck -n -t ufs /dev/md${mdstart}$part | egrep -q "BAD|WRONG"; then
+	fsck -n -t ufs /dev/md${mdstart}$part
+fi
+
+mdconfig -d -u $mdstart
+exit 0
+EOF
+#include <fcntl.h>
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <sys/wait.h>
+
+#define SIZ 4096
+char buf[SIZ];
+
+int
+main()
+{
+	int fd, i, j;
+	char name[128];
+	off_t len = 21474837416LL;
+	off_t pos;
+
+	srand48(getpid());
+	sprintf(name, "%05d.%05d", getpid(), 0);
+	fd = open(name, O_WRONLY | O_CREAT, 0666);
+	if (ftruncate(fd, len) == -1)
+		err(1, "ftruncate");
+	unlink(name);
+	sleep(1);
+
+	for (i = 0; i < 100; i++) {
+		for (j = 0; j < 100; j++) {
+			pos = lrand48() % (len - sizeof(buf));
+			if (lseek(fd, pos, SEEK_SET) == -1)
+				err(1, "lseek");
+			if (write(fd, buf, sizeof(buf)) != sizeof(buf))
+				err(1, "write");
+		}
+	}
+	close(fd);
+
+	return (0);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201012041145.oB4BjPiR064354>